
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ShipmentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const shipments = await db.shipments.create(
            {
                id: data.id || undefined,
        
        shipment_number: data.shipment_number
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        scheduled_ship_at: data.scheduled_ship_at
        ||
        null
            ,
            
        shipped_at: data.shipped_at
        ||
        null
            ,
            
        carrier: data.carrier
        ||
        null
            ,
            
        tracking_number: data.tracking_number
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await shipments.setPlant( data.plant || null, {
            transaction,
        });
        
        await shipments.setCustomer( data.customer || null, {
            transaction,
        });
        
        await shipments.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.shipments.getTableName(),
                belongsToColumn: 'documents',
                belongsToId: shipments.id,
            },
            data.documents,
            options,
        );
        

        return shipments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const shipmentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                shipment_number: item.shipment_number
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                scheduled_ship_at: item.scheduled_ship_at
            ||
            null
            ,
            
                shipped_at: item.shipped_at
            ||
            null
            ,
            
                carrier: item.carrier
            ||
            null
            ,
            
                tracking_number: item.tracking_number
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const shipments = await db.shipments.bulkCreate(shipmentsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < shipments.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.shipments.getTableName(),
                    belongsToColumn: 'documents',
                    belongsToId: shipments[i].id,
                },
                data[i].documents,
                options,
            );
        }
        

        return shipments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const shipments = await db.shipments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.shipment_number !== undefined) updatePayload.shipment_number = data.shipment_number;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.scheduled_ship_at !== undefined) updatePayload.scheduled_ship_at = data.scheduled_ship_at;
        
        
        if (data.shipped_at !== undefined) updatePayload.shipped_at = data.shipped_at;
        
        
        if (data.carrier !== undefined) updatePayload.carrier = data.carrier;
        
        
        if (data.tracking_number !== undefined) updatePayload.tracking_number = data.tracking_number;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await shipments.update(updatePayload, {transaction});

        
        
        if (data.plant !== undefined) {
            await shipments.setPlant(
              
              data.plant,
              
              { transaction }
            );
        }
        
        if (data.customer !== undefined) {
            await shipments.setCustomer(
              
              data.customer,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await shipments.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.shipments.getTableName(),
                belongsToColumn: 'documents',
                belongsToId: shipments.id,
            },
            data.documents,
            options,
        );
        

        return shipments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const shipments = await db.shipments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of shipments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of shipments) {
                await record.destroy({transaction});
            }
        });


        return shipments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const shipments = await db.shipments.findByPk(id, options);

        await shipments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await shipments.destroy({
            transaction
        });

        return shipments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const shipments = await db.shipments.findOne(
            { where },
            { transaction },
        );

        if (!shipments) {
            return shipments;
        }

        const output = shipments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.shipment_lines_shipment = await shipments.getShipment_lines_shipment({
            transaction
        });
        
        
        
        output.plant = await shipments.getPlant({
            transaction
        });
        
        
        output.customer = await shipments.getCustomer({
            transaction
        });
        
        
        output.documents = await shipments.getDocuments({
            transaction
        });
        
        
        output.organizations = await shipments.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.plants,
        as: 'plant',
        
        where: filter.plant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.plant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.plant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.customers,
        as: 'customer',
        
        where: filter.customer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.customer.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.customer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'documents',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.shipment_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shipments',
                        'shipment_number',
                        filter.shipment_number,
                    ),
                };
            }
            
            if (filter.carrier) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shipments',
                        'carrier',
                        filter.carrier,
                    ),
                };
            }
            
            if (filter.tracking_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shipments',
                        'tracking_number',
                        filter.tracking_number,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'shipments',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.scheduled_ship_atRange) {
                const [start, end] = filter.scheduled_ship_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    scheduled_ship_at: {
                    ...where.scheduled_ship_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    scheduled_ship_at: {
                    ...where.scheduled_ship_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.shipped_atRange) {
                const [start, end] = filter.shipped_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    shipped_at: {
                    ...where.shipped_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    shipped_at: {
                    ...where.shipped_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.shipments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'shipments',
                        'shipment_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.shipments.findAll({
            attributes: [ 'id', 'shipment_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['shipment_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.shipment_number,
        }));
    }

    
};

